// $Id: parseJAQ.h,v 1.4 2011/03/25 13:59:25 black Exp $
// *created  "Wed Jun 11 09:14:30 2003" *by "Paul E. Black"
// *modified "Thu Mar 24 10:34:51 2011" *by "Paul E. Black"

//-----------------------------------------------------------------------------
//
// This software was developed at the National Institute of Standards 
// and Technology by employees of the Federal Government in the course 
// of their official duties.  Pursuant to title 17 Section 105 of the 
// United States Code this software is not subject to copyright 
// protection and is in the public domain. 
// 
// We would appreciate acknowledgment if the software is used.
//
// Paul E. Black  paul.black@nist.gov
//
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//	declarations for parsing functions
//-----------------------------------------------------------------------------

#ifndef PARSEJAQ_H
#define PARSEJAQ_H

//#include "simstate.h"

typedef union {
    float f;		// a float (e.g., probability)
    int   i;		// an integer (e.g., qubit number of name)
} paramType;

enum GateBitType {BlankBit, ControlBit, HadBit, NotBit, YBit, ZBit, MeasureBit, Reset0Bit, Reset1Bit, ErrorBit};

string parseJAQ$version(void);

void processDeclaredGates();
int processQubitDecls();
void processGates();

#endif

// end of $Source: /home/black/Quantum/QCSim/RCS/parseJAQ.h,v $
