// $Id: parseQHDL.h,v 1.7 2011/03/25 13:57:11 black Exp $
// *created  "Wed Jun 11 09:14:30 2003" *by "Paul E. Black"
// *modified "Thu Mar 24 09:28:04 2011" *by "Paul E. Black"

//-----------------------------------------------------------------------------
//
// This software was developed at the National Institute of Standards 
// and Technology by employees of the Federal Government in the course 
// of their official duties.  Pursuant to title 17 Section 105 of the 
// United States Code this software is not subject to copyright 
// protection and is in the public domain. 
// 
// We would appreciate acknowledgment if the software is used.
//
// Paul E. Black  paul.black@nist.gov
//
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//	declarations for parsing functions
//-----------------------------------------------------------------------------

#ifndef PARSEQHDL_H
#define PARSEQHDL_H

#include <complex.h>

typedef struct {
    float f;		// a float (e.g., probability)
    int   i;		// an integer (e.g., qubit number of name)
    char  type;		// type: 'n': (float) number, 'q': qubit name
} paramType;

int get_decls(void);
void get_init(int ketArraySize, float complex *initialKet);
int get_gate(int *funcIndexp, paramType **parameters);
string parseQHDL$version(void);

#endif

// end of $Source: /home/black/Quantum/QCSim/RCS/parseQHDL.h,v $
