// $Id: parsingFuncs.h,v 1.8 2011/03/25 13:57:56 black Exp $
// *created  "Mon Jun  9 2003" *by "Andrew Lane"
// *modified "Thu Mar 24 10:25:14 2011" *by "Paul E. Black"

//-----------------------------------------------------------------------------
//
// This software was developed at the National Institute of Standards 
// and Technology by employees of the Federal Government in the course 
// of their official duties.  Pursuant to title 17 Section 105 of the 
// United States Code this software is not subject to copyright 
// protection and is in the public domain. 
// 
// We would appreciate acknowledgment if the software is used.
//
// Paul E. Black  paul.black@nist.gov
//
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//	declarations for parsing functions
//-----------------------------------------------------------------------------

#ifndef PARSING_FUNCS_H
#define PARSING_FUNCS_H

#include <iostream>
#include <fstream>
using namespace std;

// type of symbols returned from getNextSymbol
enum symbType {NameSymbType, NumberSymbType, PuncSymbType, EOI};

// parameter error enumeration
enum ParmErrorType {NoParmError, DupQubit, QubitOOR, ProbOOR, ParmOOR};


void getNextSymbol(void);
void expectPunct(char ch);
void dieWithError(const char *msgBuf);
void parmError(const char *gateName, int errNum);
string parsingFuncs$version(void);
void ignoreLine(void);

// the input stream
extern ifstream ins;

// SKIMP: THESE SHOULD BE READ-ONLY, E.G., METHODS
// the type of symbol extracted from input stream
extern symbType nextType;
// next name, number, or punctuation
extern char symbName[];
extern float symbNumber;
extern char symbPunct;

#endif

// end of $Source: /home/black/Quantum/QCSim/RCS/parsingFuncs.h,v $
