// $Id: simstate.h,v 1.6 2011/03/25 13:55:53 black Exp $
// *created  "Fri Sep  6 11:00:38 2002" *by "Paul E. Black"
// *modified "Wed Mar 23 18:02:25 2011" *by "Paul E. Black"

//-----------------------------------------------------------------------------
//
// This software was developed at the National Institute of S
// and Technology by employees of the Federal Government in t
// of their official duties.  Pursuant to title 17 Section 10
// United States Code this software is not subject to copyrig
// protection and is in the public domain. 
// 
// We would appreciate acknowledgment if the software is used
//
// Paul E. Black  paul.black@nist.gov
//
//-----------------------------------------------------------------------------

#ifndef SIMSTATE_INCLUDED
#define SIMSTATE_INCLUDED

#include "denmat.h"

//-----------------------------------------------------------------------------
//
// The state of the quantum computation at one time in a simulation.
// Currently it is a density matrix, but this could change.
//
//-----------------------------------------------------------------------------

// return the code version
std::string simstate$version(void);

class simstate {
  public:
    simstate(int numQubits);
    ~simstate();

    // CONSTANT MEMBER FUNCTIONS
    void print_state(){mat->print_state();}
    int Qubits() const {return mat->bits();}
    denmat *get_denmat(){return mat;}

    // MODIFICATION MEMBER FUNCTIONS
    // allocate a new simstate and initialize it to the ket passed
    void initialize(float complex ket[]);
    // trace over the qubit indicated
    void traceOver(int qubit);

  private:
    // PRIVATE MEMBER VARIABLES
    denmat *mat; // the density matrix representing this state
};

#endif

// end of $Source: /home/black/Quantum/QCSim/RCS/simstate.h,v $
